## libtree 3.0.2

=== Makefile ===
ifeq (exists, $(shell [ -e $(CURDIR)/Make.user ] && echo exists ))
include $(CURDIR)/Make.user
endif

CFLAGS ?= -O2
LIBTREE_CFLAGS := -std=c99 -Wall -Wextra -Wshadow -pedantic
LIBTREE_DEFINES := -D_FILE_OFFSET_BITS=64

PREFIX ?= /usr/local
BINDIR ?= $(PREFIX)/bin
SHAREDIR ?= $(PREFIX)/share

.PHONY: all check install clean

all: libtree

%.o: %.c
	$(CC) $(CFLAGS) $(LIBTREE_CFLAGS) $(LIBTREE_DEFINES) -c $?

libtree: libtree.o
	$(CC) $(LDFLAGS) $^ -o $@

check:: libtree

install: all
	mkdir -p $(DESTDIR)$(BINDIR)
	cp -p libtree $(DESTDIR)$(BINDIR)
	mkdir -p $(DESTDIR)$(SHAREDIR)/man/man1
	cp -p doc/libtree.1 $(DESTDIR)$(SHAREDIR)/man/man1

clean::
	rm -f *.o libtree

clean check::
	for dir in $(sort $(wildcard tests/*)); do \
		$(MAKE) -C $$dir $@ || break ;\
	done

=== tests/01_origin/Makefile ===
# Basic test of $ORIGIN interpolation in rpath & runpath.

.PHONY: clean

LD_LIBRARY_PATH:=

all: check

liba.so: 
	echo 'int f(){return 1;}' | $(CC) -shared -Wl,-soname,$@ -o $@ -nostdlib -x c -

exe_rpath: liba.so
	echo 'int _start(){return f();}' | $(CC) -o $@ -Wl,--no-as-needed -Wl,--disable-new-dtags '-Wl,-rpath,$$ORIGIN' -Wno-implicit-function-declaration -nostdlib $< -x c -

exe_runpath: liba.so
	echo 'int _start(){return f();}' | $(CC) -o $@ -Wl,--no-as-needed -Wl,--enable-new-dtags '-Wl,-rpath,$$ORIGIN' -Wno-implicit-function-declaration -nostdlib $< -x c -

check: exe_rpath exe_runpath
	../../libtree exe_rpath
	../../libtree exe_runpath

clean:
	rm -f *.so exe*

=== tests/02_rpath_of_parents_parent/Makefile ===
# This creates exe <- liba.so <- libb.so
# where liba.so cannot directly locate libb.so, but it *can* through exe's rpaths.

LD_LIBRARY_PATH:=

.PHONY: clean

all: check

libb.so: 
	echo 'int g(){return 1;}' | $(CC) -shared -Wl,-soname,$@ -o $@ -nostdlib -x c -

liba.so: libb.so
	echo 'int f(){return g();}' | $(CC) -shared -Wl,--no-as-needed -Wl,-soname,$@ -o $@ -Wno-implicit-function-declaration $< -nostdlib -x c -

exe: liba.so
	echo 'int _start(){return f();}' | $(CC) -o $@ -Wl,--no-as-needed -Wl,--disable-new-dtags '-Wl,-rpath,$$ORIGIN' '-Wl,-rpath-link,$(CURDIR)' -Wno-implicit-function-declaration -nostdlib -L. -la -x c -

check: exe liba.so
	../../libtree liba.so || true # should not find libb.so
	LD_LIBRARY_PATH=$(CURDIR) ../../libtree liba.so  # should find libb.so through LD_LIBRARY_PATH
	../../libtree exe  # should find libb.so through exe's rpath

clean:
	rm -f *.so exe*

=== tests/03_direct_and_absolute_rpath/Makefile ===
LD_LIBRARY_PATH:=

.PHONY: clean

all: check

some_dir/lib_f.so:
	mkdir some_dir
	echo 'int f(){return 42;}' | $(CC) -shared -Wl,-soname,$(notdir $@) -Wl,--no-as-needed -o $@ -x c -

lib_g.so: some_dir/lib_f.so
	echo 'extern int f(); int g(){return f();}' | $(CC) -shared -Wl,-soname,$@ -Wl,--no-as-needed "-Wl,-rpath,$(CURDIR)/some_dir" -L./some_dir -l_f -o $@ -x c -

lib_without_soname.so:
	echo 'int i(){return 1;}' | $(CC) -shared -Wl,--no-as-needed -o $@ -x c -

exe_a: some_dir/lib_f.so lib_g.so lib_without_soname.so
	echo 'extern int i(); extern int f(); extern int g(); int main(){return f() + g() + i();}' | $(CC) -Wl,--no-as-needed "-Wl,-rpath,$(CURDIR)/" -L. -L./some_dir -l_f -l_g $(CURDIR)/lib_without_soname.so -o $@ -x c -

exe_b: some_dir/lib_f.so lib_g.so lib_without_soname.so
	echo 'extern int i(); extern int f(); extern int g(); int main(){return f() + g() + i();}' | $(CC) -Wl,--no-as-needed "-Wl,-rpath,$(CURDIR)/" "-Wl,-rpath,$(CURDIR)/some_dir" -L. -L./some_dir -l_f -l_g $(CURDIR)/lib_without_soname.so -o $@ -x c -

check: exe_a exe_b
	../../libtree exe_a || true # cannot find lib_f.so
	../../libtree exe_b || true # should find lib_f.so

clean:
	rm -rf *.so some_dir exe*

=== tests/04_rpath_over_env_over_runpath/Makefile ===
LD_LIBRARY_PATH:=

# test whether RUNPATH < LD_LIBRARY_PATH < RPATH
# the exe's both need libb.so, but there are two of those:
# ./dir/libb.so needs liba.so
# ./libb.so needs nothing.

.PHONY: clean

all: check

dir:
	mkdir $@

dir/liba.so: dir
	echo 'int a(){return 42;}' | $(CC) -shared -Wl,-soname,$(notdir $@) -Wl,--no-as-needed -o $@ -nostdlib -x c -

dir/libb.so: dir/liba.so
	echo 'int b(){return a();}' | $(CC) -shared -Wl,-soname,$(notdir $@) -Wl,--no-as-needed -Wl,--disable-new-dtags '-Wl,-rpath,$$ORIGIN' -Wno-implicit-function-declaration -o $@ -nostdlib $< -x c -

libb.so:
	echo 'int b(){return 10;}' | $(CC) -shared -Wl,-soname,$(notdir $@) -Wl,--no-as-needed -o $@ -Wno-implicit-function-declaration -nostdlib -x c -

exe_rpath: libb.so
	echo 'int _start(){return b();}' | $(CC) -Wl,--no-as-needed -Wl,--disable-new-dtags "-Wl,-rpath,$(CURDIR)" $< -o $@ -Wno-implicit-function-declaration -nostdlib -x c -

exe_runpath: libb.so
	echo 'int _start(){return b();}' | $(CC) -Wl,--no-as-needed -Wl,--enable-new-dtags "-Wl,-rpath,$(CURDIR)" $< -o $@ -Wno-implicit-function-declaration -nostdlib -x c -

check: exe_rpath exe_runpath dir/libb.so
	../../libtree exe_rpath
	LD_LIBRARY_PATH="$(CURDIR)/dir" ../../libtree exe_rpath
	../../libtree exe_runpath
	LD_LIBRARY_PATH="$(CURDIR)/dir" ../../libtree exe_runpath

clean:
	rm -rf *.so dir exe*

=== tests/05_32_bits/Makefile ===
# Test 32 bits exectuables and libraries
# Make sure the 64 bits versions are not picked up.

LD_LIBRARY_PATH:=

.PHONY: clean

all: check

lib64/libx.so:
	mkdir -p $(dir $@)
	echo 'int a(){return 42;}' | $(CC) -shared -Wl,-soname,$(notdir $@) -m64 -o $@ -nostdlib -x c -

lib32/libx.so:
	mkdir -p $(dir $@)
	echo 'int a(){return 42;}' | $(CC) -shared -Wl,-soname,$(notdir $@) -m32 -o $@ -nostdlib -x c -

exe64: lib64/libx.so
	echo 'extern int a(); int _start(){return a();}' | $(CC) -m64 "-Wl,-rpath,$(CURDIR)/lib32" "-Wl,-rpath,$(CURDIR)/lib64" -o $@ -nostdlib -x c - -Llib64 -lx

exe32: lib32/libx.so
	echo 'extern int a(); int _start(){return a();}' | $(CC) -m32 "-Wl,-rpath,$(CURDIR)/lib64" "-Wl,-rpath,$(CURDIR)/lib32" -o $@ -nostdlib -x c - -Llib32 -lx

check: exe32 exe64
	../../libtree exe32
	../../libtree exe64

clean:
	rm -rf lib32 lib64 exe*

=== tests/06_symbol_versions/Makefile ===
# Creates two versions of a library with the same (so)name,
# and same symbol xyz, but versioned VER_V1 and VER_V2.
# As far as I understand, ld.so does not continue to look
# for another library in the search path which provides the
# correct symbol versions (e.g. link to VER_V2, put the VER_V1
# version first in the search ath, and glibc fixes this lib
# and simply errors).

LD_LIBRARY_PATH:=

.PHONY: clean

all: check

%/libx.so: %.c %.map
	mkdir -p $(dir $@)
	$(CC) -shared -Wl,-soname,$(notdir $@) -o $@ -Wl,--version-script,$(word 2,$^) $<

# this one is fine, link to v1, use v2 which provides the v1 symbol.
exe_v1: main.c v1/libx.so v2/libx.so
	$(CC) -o $@ $< $(word 2,$^) "-Wl,-rpath,$(CURDIR)/$(dir $(word 3,$^))" "-Wl,-rpath,$(CURDIR)/$(dir $(word 2,$^))"

# this one is not fine, link to v2, use v1 which does not provide the v2 symbol
exe_v2: main.c v1/libx.so v2/libx.so
	$(CC) -o $@ $< $(word 3,$^) "-Wl,-rpath,$(CURDIR)/$(dir $(word 2,$^))" "-Wl,-rpath,$(CURDIR)/$(dir $(word 3,$^))"

check: exe_v1 exe_v2
	../../libtree $(word 1,$^)
	../../libtree $(word 2,$^)

clean:
	rm -rf v1 v2 exe*

=== tests/07_origin_is_relative_to_symlink_location_not_realpath/Makefile ===
# ORIGIN should be resolved relative to the directory the lib was found in,
# even if what we've found is a symlink.  So this test creates exe <- a/libf <-
# a/libg and a symlink at b/libf to a/libf, where a/libf has ${ORIGIN} rpath.

LD_LIBRARY_PATH:=

.PHONY: clean

all: check

a/libf.so: 
	mkdir -p $(dir $@)
	echo 'int f(){return 3;};' | $(CC) -shared -Wl,-soname,$(notdir $@) -o $@ -x c - -nostdlib

a/libg.so: a/libf.so
	mkdir -p $(dir $@)
	echo 'extern int f(); int g(){return f();};' | $(CC) -shared -Wl,-soname,$(notdir $@) '-Wl,-rpath,$${ORIGIN}' -o $@ -x c - -La -lf -nostdlib

b/libg.so: a/libg.so
	mkdir -p $(dir $@)
	ln -vs ../$< $@

exe: a/libg.so b/libg.so
	echo 'extern int g(); int _start(){return g();};' | $(CC) -Wl,-soname,$(notdir $@) '-Wl,-rpath,$${ORIGIN}/b' -o $@ -x c - -La -lg -nostdlib

check: exe
	../../libtree exe || true # should not find libf.so
	LD_LIBRARY_PATH=$(CURDIR)/a ../../libtree exe || true # should not find libf.so

clean:
	rm -rf a b exe*

=== tests/08_nodeflib/Makefile ===
# When passing -z nodefaultlib, the runtime linker should not consider
# ld.so.conf nor standard paths (/usr/lib, /lib, ...). This is a little bit
# hard to test but in general it means that if you use the system compiler with
# this flag, libc itself would not be located.
#
# There's two tests here:
# 1. exe_a (itself nodefaultlib) depends on a lib with and a lib without -z
#    nodefaultlib
# 2. exe_b (itself nodefaultlib) depends on a lib without nodefaultlib.
#
# The question is whether or not libc can be located as a lib in the default
# paths. (The expected behavior is not well documented...)

.PHONY: clean check

LD_LIBRARY_PATH:=

all: check

lib_nodefaultlib.so: 
	echo 'int f(){return 1;}' | $(CC) -z nodefaultlib -Wl,--no-as-needed -shared -Wl,-soname,$@ -o $@ -x c -

lib_defaultlib.so:
	echo 'int g(){return 1;}' | $(CC) -Wl,--no-as-needed -shared -Wl,-soname,$@ -o $@ -x c -

exe_a: lib_nodefaultlib.so lib_defaultlib.so
	echo 'extern int f(); extern int g(); int main(){return f() + g();}' | $(CC) -z nodefaultlib -o $@ -Wl,--enable-new-dtags '-Wl,-rpath,$$ORIGIN' -x c - -L. -l_nodefaultlib -l_defaultlib

exe_b: lib_defaultlib.so
	echo 'extern int g(); int main(){return g();}' | $(CC) -z nodefaultlib -o $@ -Wl,--disable-new-dtags '-Wl,-rpath,$$ORIGIN' -x c - -L. -l_defaultlib

check: exe_a exe_b
	../../libtree -vvv exe_a || true # should likely not find libc
	../../libtree -vvv exe_b || true # should likely not find libc

clean:
	rm -f *.so exe*

=== tests/10_rpath_order/Makefile ===
# This creates exe <- liba.so <- libb.so There are two libraries:
# {first,second}/libb.so and exe has an rpath to first, whereas liba.so has an
# rpath to second

LD_LIBRARY_PATH:=

.PHONY: clean

all: check

first/libb.so: 
	@mkdir -p $(dir $@)
	echo 'int g(){return 1;}' | $(CC) -shared -Wl,-soname,$(notdir $@) -o $@ -x c -

second/libb.so: 
	@mkdir -p $(dir $@)
	echo 'int g(){return 2;}' | $(CC) -shared -Wl,-soname,$(notdir $@) -o $@ -x c -

liba.so: second/libb.so
	echo 'extern int g(); int f(){return g();}' | $(CC) -shared -Wl,--disable-new-dtags -Wl,-soname,$@ -o $@ '-Wl,-rpath,$$ORIGIN/$(dir $<)' -x c - -L$(dir $<) -lb

exe: first/libb.so liba.so
	echo 'extern int f(); int main(){return f();}' | $(CC) -o $@ -Wl,--disable-new-dtags '-Wl,-rpath,$$ORIGIN,-rpath,$$ORIGIN/$(dir $<)' -x c - -L. -la

check: exe liba.so
	../../libtree -p liba.so  # should find second/libb.so, not first/libb.so
	../../libtree -p exe  # should find second/libb.so, not first/libb.so

clean:
	rm -rf -- *.so exe* first second

=== debian/changelog ===
libtree (3.0.2-2) unstable; urgency=medium

  * Source only upload.

 -- Gürkan Myczko <tar@debian.org>  Thu, 17 Feb 2022 14:55:23 +0100

libtree (3.0.2-1) unstable; urgency=medium

  * Initial release. (Closes: #1004927)

 -- Gürkan Myczko <tar@debian.org>  Thu, 03 Feb 2022 19:18:08 +0100

=== debian/control ===
Source: libtree
Section: utils
Priority: optional
Maintainer: Gürkan Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.6.0
Homepage: https://github.com/haampie/libtree
#Vcs-Browser: https://salsa.debian.org/debian/libtree
#Vcs-Git: https://salsa.debian.org/debian/libtree.git
Rules-Requires-Root: no

Package: libtree
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ldd as a tree
 This is tool like ldd with these features:
 - turns ldd into a tree
 - explains why shared libraries are found and why not

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@

override_dh_auto_install:
	@echo manual install

## libtree 3.1.1

=== Makefile ===
-include Make.user

CFLAGS ?= -O2
LIBTREE_CFLAGS = -std=c99 -Wall -Wextra -Wshadow -pedantic
LIBTREE_DEFINES = -D_FILE_OFFSET_BITS=64

PREFIX ?= /usr/local
BINDIR ?= $(PREFIX)/bin
SHAREDIR ?= $(PREFIX)/share

.PHONY: all check install clean

all: libtree

.c.o:
	$(CC) $(CFLAGS) $(LIBTREE_CFLAGS) $(LIBTREE_DEFINES) -c $<

libtree-objs = libtree.o
libtree: $(libtree-objs)
	$(CC) $(LDFLAGS) -o $@ $(libtree-objs)

install: all
	mkdir -p $(DESTDIR)$(BINDIR)
	cp -p libtree $(DESTDIR)$(BINDIR)
	mkdir -p $(DESTDIR)$(SHAREDIR)/man/man1
	cp -p doc/libtree.1 $(DESTDIR)$(SHAREDIR)/man/man1

check:: libtree

clean::
	rm -f *.o libtree

clean check::
	find tests -mindepth 1 -maxdepth 1 -type d | while read -r dir; do \
		$(MAKE) -C "$$dir" $@ || exit 1 ;\
	done

=== tests/01_origin/Makefile ===
# Basic test of $ORIGIN interpolation in rpath & runpath.

.PHONY: clean

LD_LIBRARY_PATH=

all: check

liba.so: 
	echo 'int f(){return 1;}' | $(CC) -shared -Wl,-soname,$@ -o $@ -nostdlib -x c -

exe_rpath: liba.so
	echo 'int _start(){return f();}' | $(CC) -o $@ -Wl,--no-as-needed -Wl,--disable-new-dtags '-Wl,-rpath,$$ORIGIN' -Wno-implicit-function-declaration -nostdlib liba.so -x c -

exe_runpath: liba.so
	echo 'int _start(){return f();}' | $(CC) -o $@ -Wl,--no-as-needed -Wl,--enable-new-dtags '-Wl,-rpath,$$ORIGIN' -Wno-implicit-function-declaration -nostdlib liba.so -x c -

check: exe_rpath exe_runpath
	../../libtree exe_rpath
	../../libtree exe_runpath

clean:
	rm -f *.so exe*

=== tests/02_rpath_of_parents_parent/Makefile ===
# This creates exe <- liba.so <- libb.so
# where liba.so cannot directly locate libb.so, but it *can* through exe's rpaths.

LD_LIBRARY_PATH=

.PHONY: clean

all: check

libb.so: 
	echo 'int g(){return 1;}' | $(CC) -shared -Wl,-soname,$@ -o $@ -nostdlib -x c -

liba.so: libb.so
	echo 'int f(){return g();}' | $(CC) -shared -Wl,--no-as-needed -Wl,-soname,$@ -o $@ -Wno-implicit-function-declaration libb.so -nostdlib -x c -

exe: liba.so
	echo 'int _start(){return f();}' | $(CC) -o $@ -Wl,--no-as-needed -Wl,--disable-new-dtags '-Wl,-rpath,$$ORIGIN' '-Wl,-rpath-link,$(CURDIR)' -Wno-implicit-function-declaration -nostdlib -L. -la -x c -

check: exe liba.so
	! ../../libtree liba.so # should not find libb.so
	LD_LIBRARY_PATH=$(CURDIR) ../../libtree liba.so  # should find libb.so through LD_LIBRARY_PATH
	../../libtree exe  # should find libb.so through exe's rpath

clean:
	rm -f *.so exe*

CURDIR ?= $(.CURDIR)

=== tests/03_direct_and_absolute_rpath/Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-LD_LIBRARY_PATH:=
+LD_LIBRARY_PATH=
 
 .PHONY: clean
 
@@ -6,7 +6,7 @@
 
 some_dir/lib_f.so:
 	mkdir some_dir
-	echo 'int f(){return 42;}' | $(CC) -shared -Wl,-soname,$(notdir $@) -Wl,--no-as-needed -o $@ -x c -
+	echo 'int f(){return 42;}' | $(CC) -shared -Wl,-soname,$(@F) -Wl,--no-as-needed -o $@ -x c -
 
 lib_g.so: some_dir/lib_f.so
 	echo 'extern int f(); int g(){return f();}' | $(CC) -shared -Wl,-soname,$@ -Wl,--no-as-needed "-Wl,-rpath,$(CURDIR)/some_dir" -L./some_dir -l_f -o $@ -x c -
@@ -21,9 +21,10 @@
 	echo 'extern int i(); extern int f(); extern int g(); int main(){return f() + g() + i();}' | $(CC) -Wl,--no-as-needed "-Wl,-rpath,$(CURDIR)/" "-Wl,-rpath,$(CURDIR)/some_dir" -L. -L./some_dir -l_f -l_g $(CURDIR)/lib_without_soname.so -o $@ -x c -
 
 check: exe_a exe_b
-	../../libtree exe_a || true # cannot find lib_f.so
-	../../libtree exe_b || true # should find lib_f.so
+	! ../../libtree exe_a # cannot find lib_f.so
+	../../libtree exe_b # should find lib_f.so
 
 clean:
 	rm -rf *.so some_dir exe*
 
+CURDIR ?= $(.CURDIR)

=== tests/04_rpath_over_env_over_runpath/Makefile ===
LD_LIBRARY_PATH=

# test whether RUNPATH < LD_LIBRARY_PATH < RPATH
# the exe's both need libb.so, but there are two of those:
# ./dir/libb.so needs liba.so
# ./libb.so needs nothing.

.PHONY: clean

all: check

dir:
	mkdir $@

dir/liba.so: dir
	echo 'int a(){return 42;}' | $(CC) -shared -Wl,-soname,$(@F) -Wl,--no-as-needed -o $@ -nostdlib -x c -

dir/libb.so: dir/liba.so
	echo 'int b(){return a();}' | $(CC) -shared -Wl,-soname,$(@F) -Wl,--no-as-needed -Wl,--disable-new-dtags '-Wl,-rpath,$$ORIGIN' -Wno-implicit-function-declaration -o $@ -nostdlib dir/liba.so -x c -

libb.so:
	echo 'int b(){return 10;}' | $(CC) -shared -Wl,-soname,$(@F) -Wl,--no-as-needed -o $@ -Wno-implicit-function-declaration -nostdlib -x c -

exe_rpath: libb.so
	echo 'int _start(){return b();}' | $(CC) -Wl,--no-as-needed -Wl,--disable-new-dtags "-Wl,-rpath,$(CURDIR)" libb.so -o $@ -Wno-implicit-function-declaration -nostdlib -x c -

exe_runpath: libb.so
	echo 'int _start(){return b();}' | $(CC) -Wl,--no-as-needed -Wl,--enable-new-dtags "-Wl,-rpath,$(CURDIR)" libb.so -o $@ -Wno-implicit-function-declaration -nostdlib -x c -

check: exe_rpath exe_runpath dir/libb.so
	../../libtree exe_rpath
	LD_LIBRARY_PATH="$(CURDIR)/dir" ../../libtree exe_rpath
	../../libtree exe_runpath
	LD_LIBRARY_PATH="$(CURDIR)/dir" ../../libtree exe_runpath

clean:
	rm -rf *.so dir exe*

CURDIR ?= $(.CURDIR)

=== tests/05_32_bits/Makefile ===
# Test 32 bits exectuables and libraries
# Make sure the 64 bits versions are not picked up.

LD_LIBRARY_PATH=

.PHONY: clean

all: check

lib64/libx.so:
	mkdir -p $(@D)
	echo 'int a(){return 42;}' | $(CC) -shared -Wl,-soname,$(@F) -m64 -o $@ -nostdlib -x c -

lib32/libx.so:
	mkdir -p $(@D)
	echo 'int a(){return 42;}' | $(CC) -shared -Wl,-soname,$(@F) -m32 -o $@ -nostdlib -x c -

exe64: lib64/libx.so
	echo 'extern int a(); int _start(){return a();}' | $(CC) -m64 "-Wl,-rpath,$(CURDIR)/lib32" "-Wl,-rpath,$(CURDIR)/lib64" -o $@ -nostdlib -x c - -Llib64 -lx

exe32: lib32/libx.so
	echo 'extern int a(); int _start(){return a();}' | $(CC) -m32 "-Wl,-rpath,$(CURDIR)/lib64" "-Wl,-rpath,$(CURDIR)/lib32" -o $@ -nostdlib -x c - -Llib32 -lx

check: exe32 exe64
	../../libtree exe32
	../../libtree exe64

clean:
	rm -rf lib32 lib64 exe*

CURDIR ?= $(.CURDIR)

=== tests/06_symbol_versions/Makefile ===
# Creates two versions of a library with the same (so)name,
# and same symbol xyz, but versioned VER_V1 and VER_V2.
# As far as I understand, ld.so does not continue to look
# for another library in the search path which provides the
# correct symbol versions (e.g. link to VER_V2, put the VER_V1
# version first in the search ath, and glibc fixes this lib
# and simply errors).

LD_LIBRARY_PATH=

.PHONY: clean

all: check

v1/libx.so: v1.c v1.map
v2/libx.so: v2.c v2.map
v1/libx.so v2/libx.so:
	mkdir -p $(@D)
	$(CC) -shared -Wl,-soname,$(@F) -o $@ -Wl,--version-script,$(@D).map $(@D).c

# this one is fine, link to v1, use v2 which provides the v1 symbol.
exe_v1: main.c v1/libx.so v2/libx.so
	$(CC) -o $@ main.c v1/libx.so "-Wl,-rpath,$(CURDIR)/v2" "-Wl,-rpath,$(CURDIR)/v1"

# this one is not fine, link to v2, use v1 which does not provide the v2 symbol
exe_v2: main.c v1/libx.so v2/libx.so
	$(CC) -o $@ main.c v2/libx.so "-Wl,-rpath,$(CURDIR)/v1" "-Wl,-rpath,$(CURDIR)/v2"

check: exe_v1 exe_v2
	../../libtree exe_v1
	../../libtree exe_v2

clean:
	rm -rf v1 v2 exe*

CURDIR ?= $(.CURDIR)

=== tests/07_origin_is_relative_to_symlink_location_not_realpath/Makefile ===
# ORIGIN should be resolved relative to the directory the lib was found in,
# even if what we've found is a symlink.  So this test creates exe <- a/libf <-
# a/libg and a symlink at b/libf to a/libf, where a/libf has ${ORIGIN} rpath.

LD_LIBRARY_PATH=

.PHONY: clean

all: check

a/libf.so: 
	mkdir -p $(@D)
	echo 'int f(){return 3;};' | $(CC) -shared -Wl,-soname,$(@F) -o $@ -x c - -nostdlib

a/libg.so: a/libf.so
	mkdir -p $(@D)
	echo 'extern int f(); int g(){return f();};' | $(CC) -shared -Wl,-soname,$(@F) '-Wl,-rpath,$${ORIGIN}' -o $@ -x c - -La -lf -nostdlib

b/libg.so: a/libg.so
	mkdir -p $(@D)
	ln -vs ../a/libg.so $@

exe: a/libg.so b/libg.so
	echo 'extern int g(); int _start(){return g();};' | $(CC) -Wl,-soname,$(@F) '-Wl,-rpath,$${ORIGIN}/b' -o $@ -x c - -La -lg -nostdlib

check: exe
	! ../../libtree exe # should not find libf.so
	LD_LIBRARY_PATH=$(CURDIR)/a ../../libtree exe # should find libf.so

clean:
	rm -rf a b exe*

CURDIR ?= $(.CURDIR)

=== tests/08_nodeflib/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 .PHONY: clean check
 
-LD_LIBRARY_PATH:=
+LD_LIBRARY_PATH=
 
 all: check
 
@@ -30,8 +30,8 @@
 	echo 'extern int g(); int main(){return g();}' | $(CC) -z nodefaultlib -o $@ -Wl,--disable-new-dtags '-Wl,-rpath,$$ORIGIN' -x c - -L. -l_defaultlib
 
 check: exe_a exe_b
-	../../libtree -vvv exe_a || true # should likely not find libc
-	../../libtree -vvv exe_b || true # should likely not find libc
+	! ../../libtree -vvv exe_a # should likely not find libc
+	! ../../libtree -vvv exe_b # should likely not find libc
 
 clean:
 	rm -f *.so exe*

=== tests/10_rpath_order/Makefile ===
# This creates exe <- liba.so <- libb.so There are two libraries:
# {first,second}/libb.so and exe has an rpath to first, whereas liba.so has an
# rpath to second

LD_LIBRARY_PATH=

.PHONY: clean

all: check

first/libb.so: 
	@mkdir -p $(@D)
	echo 'int g(){return 1;}' | $(CC) -shared -Wl,-soname,$(@F) -o $@ -x c -

second/libb.so: 
	@mkdir -p $(@D)
	echo 'int g(){return 2;}' | $(CC) -shared -Wl,-soname,$(@F) -o $@ -x c -

liba.so: second/libb.so
	echo 'extern int g(); int f(){return g();}' | $(CC) -shared -Wl,--disable-new-dtags -Wl,-soname,$@ -o $@ '-Wl,-rpath,$$ORIGIN/second' -x c - -Lsecond -lb

exe: first/libb.so liba.so
	echo 'extern int f(); int main(){return f();}' | $(CC) -o $@ -Wl,--disable-new-dtags '-Wl,-rpath,$$ORIGIN,-rpath,$$ORIGIN/first' -x c - -L. -la

check: exe liba.so
	../../libtree -p liba.so  # should find second/libb.so, not first/libb.so
	../../libtree -p exe  # should find second/libb.so, not first/libb.so

clean:
	rm -rf -- *.so exe* first second

=== debian/changelog ===
libtree (3.1.1-4) unstable; urgency=medium

  * Bump standards version to 4.7.2.
  * d/control: drop Rules-Requires-Root.
  * d/copyright: bump year.
  * d/watch: update to version 5.

 -- Alex Myczko <tar@debian.org>  Wed, 10 Dec 2025 14:35:04 +0000

libtree (3.1.1-3) unstable; urgency=medium

  * Bump standards version to 4.7.0.

 -- Alex Myczko <tar@debian.org>  Mon, 15 Jul 2024 21:44:17 +0000

libtree (3.1.1-2) unstable; urgency=medium

  * Fix FTBFS, thanks for the patch, Long Eric. (Closes: #1015715)

 -- Gürkan Myczko <tar@debian.org>  Fri, 19 Aug 2022 10:01:27 +0200

libtree (3.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump standards version to 4.6.1.
  * d/control: add Vcs fields.

 -- Gürkan Myczko <tar@debian.org>  Wed, 18 May 2022 12:35:04 +0200

libtree (3.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Gürkan Myczko <tar@debian.org>  Wed, 09 Mar 2022 08:29:01 +0100

libtree (3.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Gürkan Myczko <tar@debian.org>  Fri, 25 Feb 2022 12:15:18 +0100

=== debian/control ===
Source: libtree
Section: utils
Priority: optional
Maintainer: Alex Myczko <tar@debian.org>
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.7.2
Homepage: https://github.com/haampie/libtree
Vcs-Browser: https://salsa.debian.org/debian/libtree
Vcs-Git: https://salsa.debian.org/debian/libtree.git

Package: libtree
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ldd as a tree
 This is tool like ldd with these features:
 - turns ldd into a tree
 - explains why shared libraries are found and why not

=== debian/watch ===
Version: 5

# GitHub hosted projects
Template: Github
Owner: haampie
Project: libtree
Update-Script: uupdate
